import { SvelteComponent, init, safe_not_equal, element, attr, insert, noop, detach } from 'svelte/internal';
import { onMount } from 'svelte';
import QRious from 'qrious';

/* src/lib/index.svelte generated by Svelte v3.22.3 */

function create_fragment(ctx) {
	let img;
	let img_src_value;

	return {
		c() {
			img = element("img");
			if (img.src !== (img_src_value = /*image*/ ctx[2])) attr(img, "src", img_src_value);
			attr(img, "alt", /*value*/ ctx[0]);
			attr(img, "class", /*className*/ ctx[1]);
		},
		m(target, anchor) {
			insert(target, img, anchor);
		},
		p(ctx, [dirty]) {
			if (dirty & /*image*/ 4 && img.src !== (img_src_value = /*image*/ ctx[2])) {
				attr(img, "src", img_src_value);
			}

			if (dirty & /*value*/ 1) {
				attr(img, "alt", /*value*/ ctx[0]);
			}

			if (dirty & /*className*/ 2) {
				attr(img, "class", /*className*/ ctx[1]);
			}
		},
		i: noop,
		o: noop,
		d(detaching) {
			if (detaching) detach(img);
		}
	};
}

function instance($$self, $$props, $$invalidate) {
	const QRcode = new QRious();
	let { errorCorrection = "L" } = $$props;
	let { background = "#fff" } = $$props;
	let { color = "#000" } = $$props;
	let { size = "200" } = $$props;
	let { value = "" } = $$props;
	let { padding = 0 } = $$props;
	let { className = "qrcode" } = $$props;
	let image = "";

	function generateQrCode() {
		QRcode.set({
			background,
			foreground: color,
			level: errorCorrection,
			padding,
			size,
			value
		});

		$$invalidate(2, image = QRcode.toDataURL("image/jpeg"));
	}

	onMount(() => {
		generateQrCode();
	});

	$$self.$set = $$props => {
		if ("errorCorrection" in $$props) $$invalidate(3, errorCorrection = $$props.errorCorrection);
		if ("background" in $$props) $$invalidate(4, background = $$props.background);
		if ("color" in $$props) $$invalidate(5, color = $$props.color);
		if ("size" in $$props) $$invalidate(6, size = $$props.size);
		if ("value" in $$props) $$invalidate(0, value = $$props.value);
		if ("padding" in $$props) $$invalidate(7, padding = $$props.padding);
		if ("className" in $$props) $$invalidate(1, className = $$props.className);
	};

	$$self.$$.update = () => {
		if ($$self.$$.dirty & /*value*/ 1) {
			 {
				if (value) {
					generateQrCode();
				}
			}
		}
	};

	return [value, className, image, errorCorrection, background, color, size, padding];
}

class Lib extends SvelteComponent {
	constructor(options) {
		super();

		init(this, options, instance, create_fragment, safe_not_equal, {
			errorCorrection: 3,
			background: 4,
			color: 5,
			size: 6,
			value: 0,
			padding: 7,
			className: 1
		});
	}
}

export default Lib;
